# $PostgresPy: dist/config/postgresql.m4,v 1.3 2004/07/02 08:28:00 flaw Exp $
#
# † Instrument:
##
# Independent PostGresql Package [AutoConf Utilities]
##
AC_DEFUN([IPGP_INIT],
[
AC_ARG_WITH(postgresql,
	AC_HELP_STRING(
		[--with-postgresql=/path/to/pg_config],
		[PostgreSQL installation to base build on]
	)
)

PG=pg_config
test "$with_postgresql" && PG="$with_postgresql"
AC_PATH_PROG(PG, "$PG")

if ! "$PG" --help >&- 2>&-
then
	AC_MSG_ERROR(["$PG" is not executable, specify --with-postgresql=PATH_TO/pg_config])
fi
])

AC_DEFUN([IPGP_VARS],
[AC_REQUIRE([IPGP_INIT])
PG_BINDIR="$("$PG" --bindir)"
PG_LIBDIR="$("$PG" --libdir)"
PG_INCDIR="$("$PG" --includedir)"
PG_INCDIR_SERVER="$("$PG" --includedir-server)"
PG_PKGLIBDIR="$("$PG" --pkglibdir)"
PG_VERSION_STR="$("$PG" --version)"
PG_VERSION="${PG_VERSION_STR##PostgreSQL }"
PG_STATUS="${PG_VERSION##*[0-9]}"
PG_VERSION_NUMS="${PG_VERSION%%$PG_STATUS}"
PG_MAJOR="${PG_VERSION_NUMS%%.*}"
PG_MINOR="${PG_VERSION_NUMS##$PG_MAJOR.}"
if test "${#PG_VERSION_NUMS}" -gt 3
then
	PG_PATCH="${PG_VERSION_NUMS##*.}"
	PG_MINOR="${PG_MINOR%%.$PG_PATCH}"
else
	PG_PATCH=0
fi
PG_MM="$PG_MAJOR$PG_MINOR"
])

AC_DEFUN([IPGP],
[AC_REQUIRE([IPGP_VARS])

])
