# $PostgresPy: dist/config/python.m4,v 1.2 2004/07/02 08:28:00 flaw Exp $
#
# † Instrument:
##
# Python Embedder's Package
##
AC_DEFUN([PEP_INIT],
[
AC_ARG_WITH(python,
	AC_HELP_STRING(
		[--with-python=/path/to/python],
		[Python installation to base build on]
	)
)

PY=python
test "$with_python" && PY="$with_python"
AC_PATH_PROG(PY, "$PY")
if ! test -x "$PY"
then
	AC_MSG_ERROR(["$PY" is not executable, specify --with-python=PATH_TO/python])
fi
])

AC_DEFUN([PEP_VARS],
[AC_REQUIRE([PEP_INIT])
PY_VERSION_STR="$("$PY" 2>&1 -V)"
PY_MAJOR="$("$PY" -c 'from sys import version_info as vi; print vi[[0]]')"
PY_MINOR="$("$PY" -c 'from sys import version_info as vi; print vi[[1]]')"
PY_PATCH="$("$PY" -c 'from sys import version_info as vi; print vi[[2]]')"
PY_STATE="$("$PY" -c 'from sys import version_info as vi; print vi[[3]]')"
PY_MM="$PY_MAJOR$PY_MINOR"
PY_PREFIX="$("$PY" -c 'import sys; print sys.prefix')"
PY_EPREFIX="$("$PY" -c 'import sys; print sys.exec_prefix')"
PY_INCDIR="$("$PY" -c 'from distutils.sysconfig import get_python_inc as f; print f()')"
PY_LIBDIR="$("$PY" -c 'from distutils.sysconfig import get_python_lib as f; print f()')"
PY_CONFIG="${PY_EPREFIX}/lib/python${PY_MM}/config"
PY_CONFIG_H="$("$PY" -c 'from distutils.sysconfig import get_config_h_filename as f; print f()')"
])
# PEP_VARS

AC_DEFUN([PEP],
[AC_REQUIRE([PEP_VARS])
])
